net.dontdrinkandroot.lastfm.api.ws

## Interface LastfmWebServices

All Known Implementing Classes:
  AbstractLastfmWebServices, DefaultLastfmWebServices

    public interface LastfmWebServices

### Method Summary

Methods
`<T extends Serializable> T` `execute(PostQuery<T> query)` Execute an authenticated POST Query.
`<T extends Serializable> T` `fetch(AuthenticatedGetQuery<T> query)` Fetch an authenticated GET Query.
`<T extends Serializable> T` `fetch(UnauthenticatedGetQuery<T> query)` Fetch an unauthenticated GET Query.
`String` `getApiKey()` Get the current api key.
`String` `getApiSecret()` Get the current api secret.
`Fetcher` `getFetcher()` Get the current fetcher.
`void` `setFetcher(Fetcher diskBufferedFetcher)` Sets the current fetcher.

### Method Detail

#### fetch

    <T extends Serializable> T fetch(UnauthenticatedGetQuery<T> query)
                                 throws LastfmWebServicesException

Fetch an unauthenticated GET Query.

Type Parameters:
  `T` - The return type of the query.
Parameters:
  `query` - The query.
Returns:
  The desired return object.
Throws:
  `LastfmWebServicesException` - If fetching the Query fails.

#### fetch

    <T extends Serializable> T fetch(AuthenticatedGetQuery<T> query)
                                 throws LastfmWebServicesException

Fetch an authenticated GET Query.

Type Parameters:
  `T` - The return type of the Query.
Parameters:
  `query` - The query.
Returns:
  The desired return object.
Throws:
  `LastfmWebServicesException` - If fetching the Query fails.

#### execute

    <T extends Serializable> T execute(PostQuery<T> query)
                                   throws LastfmWebServicesException

Execute an authenticated POST Query.

Type Parameters:
  `T` - The return type of the query.
Parameters:
  `query` - The query.
Returns:
  The desired return object.
Throws:
  `LastfmWebServicesException` - If executing the Query fails.

#### getFetcher

    Fetcher getFetcher()

Get the current fetcher.

Returns:
  The `Fetcher` responsible for fetching the data.

#### setFetcher

    void setFetcher(Fetcher diskBufferedFetcher)

Sets the current fetcher.

Parameters:
  `diskBufferedFetcherThe` - `Fetcher` responsible for fetching the data.

#### getApiKey

    String getApiKey()

Get the current api key.

Returns:
  The current api key.

#### getApiSecret

    String getApiSecret()

Get the current api secret.

Returns:
  The current api secret.